#include<iostream>
#include<cstdlib>
#include<cassert>
#include<vector>
#include<algorithm>
using namespace std;

int get_rand(int lo, int up) {
  return lo + rand() % (up-lo+1);
}

int main(int argn, char* args[]) {
  int N, Q;
  int lo, up;

  assert(argn == 6);

  N = atoi(args[1]);
  Q = atoi(args[2]);
  lo = atoi(args[3]);
  up = atoi(args[4]);
  srand( atoi(args[5]) );

  assert( Q < N );

  vector<bool> what(N-Q, false);
  vector<bool> trues(Q, true);
  what.insert( what.end(), trues.begin(), trues.end() );
  random_shuffle(what.begin()+1, what.end());

  assert((int)what.size() == N);

  int curr_points = 0;

  cout << N << endl;
  for(int i=0; i<N-1; i++) {
    if (what[i]) {
      // query
      assert(curr_points > 0);
      cout << "2 " << curr_points - (rand() % curr_points/5) << endl;
    } else {
      // new point
      ++curr_points;
      cout << "1 "
        << get_rand(lo,up) << " "
        << get_rand(lo,up) << endl;
    }
  }

  cout << "2 " << N-1-Q << endl;

  return 0;
}
